<?xml version="1.0" encoding="UTF-8"?>

<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>ru.potapov.tm</groupId>
    <artifactId>tm-client</artifactId>
    <version>1.0.0</version>

    <name>tm-client</name>
    <!-- FIXME change it to the project's website -->
    <url>http://www.example.com</url>

    <dependencies>

        <dependency>
            <groupId>junit</groupId>
            <artifactId>junit</artifactId>
            <version>4.11</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>com.jcabi</groupId>
            <artifactId>jcabi-manifests</artifactId>
            <version>1.1</version>
        </dependency>

        <dependency>
            <groupId>org.jetbrains</groupId>
            <artifactId>annotations</artifactId>
            <version>17.0.0</version>
        </dependency>

        <dependency>
            <groupId>org.projectlombok</groupId>
            <artifactId>lombok</artifactId>
            <version>1.18.10</version>
            <scope>provided</scope>
        </dependency>

        <!-- https://mvnrepository.com/artifact/org.reflections/reflections -->
        <dependency>
            <groupId>org.reflections</groupId>
            <artifactId>reflections</artifactId>
            <version>0.9.10</version>
        </dependency>

        <!--: MAVEN-ЗАВИСИМОСТИ ДЛЯ JAX-B в JSON-->
        <dependency>
            <groupId>org.eclipse.persistence</groupId>
            <artifactId>org.eclipse.persistence.moxy</artifactId>
            <version>2.6.0</version>
        </dependency>

        <!--MAVEN-ЗАВИСИМОСТИ ДЛЯ FASTERXML-->
        <!--json-->
        <dependency>
            <groupId>com.fasterxml.jackson.core</groupId>
            <artifactId>jackson-databind</artifactId>
            <version>2.9.8</version>
        </dependency>
        <!--xml-->
        <dependency>
            <groupId>com.fasterxml.jackson.dataformat</groupId>
            <artifactId>jackson-dataformat-xml</artifactId>
            <version>2.9.8</version>
        </dependency>

        <!-- read any attribute from any of available MANIFEST.MF files -->
        <!--<dependency>-->
        <!--<groupId>com.jcabi</groupId>-->
        <!--<artifactId>jcabi-manifests</artifactId>-->
        <!--<version>0.7.5</version>-->
        <!--</dependency>-->

    </dependencies>

    <scm>
        <connection>scm:svn:http://127.0.0.1/dummy</connection>
        <developerConnection>
            scm:svn:https://127.0.0.1/dummy
        </developerConnection>
        <tag>HEAD</tag>
        <url>http://127.0.0.1/dummy</url>
    </scm>

    <build>
        <plugins>

            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-jar-plugin</artifactId>
                <configuration>
                    <archive>
                        <manifest>
                            <addClasspath>true</addClasspath>
                            <mainClass>ru.potapov.tm.Application</mainClass>
                            <addClasspath>true</addClasspath>
                            <classpathPrefix>r../lib</classpathPrefix>
                        </manifest>
                        <manifestEntries>
                            <mode>development</mode>
                            <buildNumber>${buildNumber}</buildNumber>
                            <Implementation-Version>${buildNumber}</Implementation-Version>
                            <Built-By>Potapov Dmitry</Built-By>
                        </manifestEntries>

                    </archive>
                </configuration>
            </plugin>

            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-dependency-plugin</artifactId>
                <version>3.0.1</version>
                <executions>
                    <execution>
                        <id>copy</id>
                        <phase>install</phase>
                        <goals>
                            <goal>copy</goal>
                        </goals>
                    </execution>

                    <execution>
                        <id>copy-dependencies</id>
                        <phase>prepare-package</phase>
                        <goals>
                            <goal>copy-dependencies</goal>
                        </goals>
                        <configuration>
                            <outputDirectory>
                                ${project.build.directory}/release/lib
                            </outputDirectory>
                            <overWriteReleases>false</overWriteReleases>
                            <overWriteSnapshots>false</overWriteSnapshots>
                            <overWriteIfNewer>true</overWriteIfNewer>
                        </configuration>
                    </execution>
                </executions>
                <configuration>
                    <artifactItems>
                        <artifactItem>
                            <groupId>ru.potapov.tm</groupId>
                            <artifactId>tm-client</artifactId>
                            <!--<version>${buildNumber}</version>-->
                            <version>1.0.0</version>
                            <type>jar</type>
                            <overWrite>true</overWrite>
                            <outputDirectory>
                                ${project.build.directory}/release/bin
                            </outputDirectory>
                            <destFileName>tm-client.jar</destFileName>
                        </artifactItem>
                    </artifactItems>
                    <overWriteReleases>false</overWriteReleases>
                    <overWriteSnapshots>true</overWriteSnapshots>
                </configuration>
            </plugin>

            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>3.8.0</version>
                <configuration>
                    <source>1.8</source>
                    <target>1.8</target>
                </configuration>
            </plugin>

            <plugin>
                <groupId>org.codehaus.mojo</groupId>
                <artifactId>buildnumber-maven-plugin</artifactId>
                <version>1.4</version>
                <executions>
                    <execution>
                        <id>buildNumber</id>
                        <phase>validate</phase>
                        <goals>
                            <goal>create</goal>
                        </goals>
                    </execution>
                </executions>
                <configuration>
                    <format>{0,number}</format>
                    <items>
                        <item>buildNumber</item>
                    </items>
                    <doCheck>false</doCheck>
                    <doUpdate>false</doUpdate>
                    <revisionOnScmFailure>
                        unknownBuild
                    </revisionOnScmFailure>
                </configuration>
            </plugin>

            <!--КОНФИГУРАЦИЯ ГЕНЕРАЦИИ КЛИЕНТА ПО WSDL-->
            <!--<plugin>-->
                <!--<groupId>org.apache.cxf</groupId>-->
                <!--<artifactId>cxf-codegen-plugin</artifactId>-->
                <!--<version>3.2.7</version>-->
                <!--<executions>-->
                    <!--<execution>-->
                        <!--<id>generate-sources</id>-->
                        <!--<phase>generate-sources</phase>-->
                        <!--<configuration>-->
                            <!--<sourceRoot>-->
                                <!--${project.basedir}/src/main/java-->
                            <!--</sourceRoot>-->
                            <!--<wsdlOptions>-->
                                <!--<wsdlOption>-->
                                    <!--<wsdl>-->
                                        <!--http://localhost:8080/ProjectEndpoint?wsdl-->
                                    <!--</wsdl>-->
                                <!--</wsdlOption>-->
                                <!--<wsdlOption>-->
                                    <!--<wsdl>-->
                                        <!--http://localhost:8080/SessionEndpoint?wsdl-->
                                    <!--</wsdl>-->
                                <!--</wsdlOption>-->
                                <!--<wsdlOption>-->
                                    <!--<wsdl>-->
                                        <!--http://localhost:8080/TaskEndpoint?wsdl-->
                                    <!--</wsdl>-->
                                <!--</wsdlOption>-->
                                <!--<wsdlOption>-->
                                    <!--<wsdl>-->
                                        <!--http://localhost:8080/UserEndpoint?wsdl-->
                                    <!--</wsdl>-->
                                <!--</wsdlOption>-->
                            <!--</wsdlOptions>-->
                        <!--</configuration>-->
                        <!--<goals>-->
                            <!--<goal>wsdl2java</goal>-->
                        <!--</goals>-->
                    <!--</execution>-->
                <!--</executions>-->
            <!--</plugin>-->

        </plugins>
    </build>

    <developers>
        <developer>
            <id>pd</id>
            <name>Potapov Dmitry</name>
            <email>dmitriyp.potapov@gmail.com</email>
            <url>https://gitlab.com/learningITeco/se/tm_se_08</url>
            <organization>I-TECO</organization>
            <roles>
                <role>architect</role>
                <role>developer</role>
            </roles>
        </developer>
    </developers>
</project>
